unit TestAHLbx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AHListBox, ExtCtrls, Buttons, ComCtrls, StdCtrls, ColorGrd, Menus;

type
  TTestForm = class(TForm)
    Panel1: TPanel;
    ColorGrid2: TColorGrid;
    Label2: TLabel;
    cbBarFont: TComboBox;
    edBarSize: TEdit;
    UpDown1: TUpDown;
    BarBold: TSpeedButton;
    BarItalic: TSpeedButton;
    BarUnderline: TSpeedButton;
    Bevel1: TBevel;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Panel2: TPanel;
    Panel3: TPanel;
    cbFont: TComboBox;
    Edit1: TEdit;
    UpDown2: TUpDown;
    Bold: TSpeedButton;
    Underline: TSpeedButton;
    Italic: TSpeedButton;
    LeftBtn: TSpeedButton;
    CenterBtn: TSpeedButton;
    RightBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label4: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ColorGrid1: TColorGrid;
    Label7: TLabel;
    btn16: TSpeedButton;
    btn32: TSpeedButton;
    btnNone: TSpeedButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label6: TLabel;
    Edit2: TEdit;
    UpDown3: TUpDown;
    StatusBar1: TStatusBar;
    Edit3: TEdit;
    UpDown4: TUpDown;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure rbRaisedClick(Sender: TObject);
    procedure btn16Click(Sender: TObject);
    procedure LeftBtnClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure edBarSizeChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure cbFontChange(Sender: TObject);
    procedure cbBarFontChange(Sender: TObject);
    procedure BoldClick(Sender: TObject);
    procedure BarBoldClick(Sender: TObject);
    procedure ColorGrid1Change(Sender: TObject);
    procedure ColorGrid2Change(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
  private
    { Private declarations }
    ahLbx: TAHListBox;
    procedure GetIndex(Sender: TObject; const Index: Integer; var idx: Integer);
  public
    { Public declarations }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.FormCreate(Sender: TObject);
var i: Integer;
begin
  ahLbx := TAHListBox.Create(Self);
  with ahLbx do begin
    Parent          := Panel2;
    Align           := alClient;
    Font.Name       := 'Arial';
    Font.Size       := 8;
    Font.Color      := clBlack;
    Visible         := True;
    Images          := ImageList1;
    BarColor        := clSilver;
    BarFont.Name    := 'Arial';
    BarFont.Size    := 8;
    BarFont.Color   := clWhite;
    Color           := clSilver;
    OnGetImageIndex := GetIndex;
    Sorted          := True;
    
    for i := 0 to 100 do
      Items.Add( IntToStr(i) + '.- The Item #' + IntToStr(i) );
  end;

  cbFont.Items.Assign( Screen.Fonts );
  cbFont.ItemIndex := cbFont.Items.IndexOF( 'Arial' );
  cbBarFont.Items.Assign( Screen.Fonts );
  cbBarFont.ItemIndex := cbFont.Items.IndexOF( 'Arial' );

end;

procedure TTestForm.rbRaisedClick(Sender: TObject);
begin
  ahLbx.BarStyle := TBarStyle(TRadioButton(Sender).Tag);
end;

procedure TTestForm.GetIndex(Sender: TObject; const Index: Integer; var idx: Integer);
begin
  if Index > ahLbx.Images.Count - 1 then idx := 0 else idx := Index;
end;

procedure TTestForm.btn16Click(Sender: TObject);
begin
  if btn16.Down then ahLbx.Images := ImageList1
  else if btn32.Down then ahLbx.Images := ImageList2
  else ahLbx.Images := nil;
end;

procedure TTestForm.LeftBtnClick(Sender: TObject);
begin
  ahLbx.Alignment := TAlignment(TSpeedButton(Sender).Tag);
end;

procedure TTestForm.CheckBox1Click(Sender: TObject);
begin
  ahLbx.MultiSelect := CheckBox1.Checked;
end;

procedure TTestForm.Edit2Change(Sender: TObject);
begin
  ahLbx.Offset := UpDown3.Position;
end;

procedure TTestForm.edBarSizeChange(Sender: TObject);
begin
 ahLbx.BarFont.Size := UpDown1.Position;
end;

procedure TTestForm.Edit1Change(Sender: TObject);
begin
  ahLbx.Font.Size := UpDown2.Position;
end;

procedure TTestForm.cbFontChange(Sender: TObject);
begin
  ahLbx.Font.Name    := cbFont.Text;
end;

procedure TTestForm.cbBarFontChange(Sender: TObject);
begin
  ahLbx.BarFont.Name := cbBarFont.Text;
end;

procedure TTestForm.BoldClick(Sender: TObject);
begin
 if Bold.Down then
  ahLbx.Font.Style := ahLbx.Font.Style + [fsBold]
 else
  ahLbx.Font.Style := ahLbx.Font.Style - [fsBold];

 if Italic.Down then
  ahLbx.Font.Style := ahLbx.Font.Style + [fsItalic]
 else
  ahLbx.Font.Style := ahLbx.Font.Style - [fsItalic];

 if Underline.Down then
  ahLbx.Font.Style := ahLbx.Font.Style + [fsUnderline]
 else
  ahLbx.Font.Style := ahLbx.Font.Style - [fsUnderline];

end;

procedure TTestForm.BarBoldClick(Sender: TObject);
begin
 if BarBold.Down then
  ahLbx.BarFont.Style := ahLbx.BarFont.Style + [fsBold]
 else
  ahLbx.BarFont.Style := ahLbx.BarFont.Style - [fsBold];

 if BarItalic.Down then
  ahLbx.BarFont.Style := ahLbx.BarFont.Style + [fsItalic]
 else
  ahLbx.BarFont.Style := ahLbx.BarFont.Style - [fsItalic];

 if BarUnderline.Down then
  ahLbx.BarFont.Style := ahLbx.BarFont.Style + [fsUnderline]
 else
  ahLbx.BarFont.Style := ahLbx.BarFont.Style - [fsUnderline];

end;

procedure TTestForm.ColorGrid1Change(Sender: TObject);
begin
  ahLbx.Color      := ColorGrid1.BackgroundColor;
  ahLbx.Font.Color := ColorGrid1.ForegroundColor;
end;

procedure TTestForm.ColorGrid2Change(Sender: TObject);
begin
  ahLbx.BarColor      := ColorGrid2.BackgroundColor;
  ahLbx.BarFont.Color := ColorGrid2.ForegroundColor;
end;


procedure TTestForm.SpeedButton3Click(Sender: TObject);
begin
  ahLbx.ImagePos := TImagePos(TSpeedButton(Sender).Tag);
end;

procedure TTestForm.SpeedButton2Click(Sender: TObject);
begin
  ahLbx.BarStyle := TBarStyle(TSpeedButton(Sender).Tag);
end;

procedure TTestForm.CheckBox2Click(Sender: TObject);
begin
  ahLbx.OddEvenColors := CheckBox2.Checked;
end;

procedure TTestForm.Edit3Change(Sender: TObject);
begin
 ahlbx.Columns := updown4.position;
end;

end.
